<template>
  <JMenu
    open-by-right-click
    dynamic-position
    :max-height="false"
  >
    <template #activator="menuProps">
      <div
        v-if="message.details?.isEdit"
        @keydown.space.stop
      >
        <EditMessage
          :message="message"
          :chat-id="chatId"
          @cancel="
            setEditStatus(chatId, message.id, false);
            setEditMessageValue(chatId, message.id, '');
            setShowingReplyInEditMessage(chatId, message.id, !!message.replyTo);
          "
        />
      </div>
      <JKeyboardNavItem
        v-else
        #default="a11yProps"
      >
        <div
          @click.right.capture="onRightClick($event, message)"
          @keydown.capture.space="restoreDeletedMessage($event, message)"
          @keydown.capture.enter="restoreDeletedMessage($event, message)"
        >
          <ChatMessage
            v-bind="mergeProps(a11yProps, menuProps)"
            :personal="isPersonal"
            :message="message"
            @restore="restoreMessage(message.id, chatId)"
          />
        </div>
      </JKeyboardNavItem>
    </template>

    <ConversationMessageListActions
      :hide-edit="!isPersonal"
      :hide-delete="!isPersonal"
      @reply="setReplyMessage(chatId, message)"
      @edit="
        setShowingReplyInEditMessage(chatId, message.id, true);
        setEditStatus(chatId, message.id, true);
      "
      @delete="
        deleteMessage({
          chatId: chatId,
          messageId: message.id,
        })
      "
    />
  </JMenu>
</template>

<script setup lang="ts">
import { PropType, computed, mergeProps } from 'vue';
import { storeToRefs } from 'pinia';
import { JMenu, JKeyboardNavItem } from '@new-jira-clone/ui/src/components';
import { useUserStore } from '@new-jira-clone/libs/src/store';
import { EditMessage } from '@/features/edit-message';
import { useDeleteMessage } from '@/features/delete-message';
import { useRestoreMessage } from '@/features/restore-message';
import { useMessageDetailsService, ChatMessage } from '@/entities/Message';
import { useConversationDetailsService } from '@/entities/Conversation';
import { IMessage } from '@/shared';
import ConversationMessageListActions from './ConversationMessageListActions.vue';

const props = defineProps({
  chatId: {
    type: String,
    required: true,
  },
  message: {
    type: Object as PropType<IMessage>,
    required: true,
  },
});

const { getUser } = storeToRefs(useUserStore());

const { deleteMessage } = useDeleteMessage();
const { restoreMessage } = useRestoreMessage();
const { setReplyMessage } = useConversationDetailsService();
const {
  setEditStatus,
  setEditMessageValue,
  setShowingReplyInEditMessage,
} = useMessageDetailsService();

const isPersonal = computed(() => getUser.value?.id === props.message.author?.id);

const restoreDeletedMessage = (event: KeyboardEvent, message: IMessage): void => {
  if (message.deletedDate) {
    event.stopPropagation();
    restoreMessage(props.message.id, props.chatId);
  }
};

const onRightClick = (event: MouseEvent, message: IMessage): void => {
  if (message.deletedDate) {
    event.preventDefault();
    event.stopPropagation();
  }
};
</script>
